<?php
namespace app\user\behavior;

use think\Controller;

class Hook extends Controller
{
    // 表单生成
    public function formBuild(&$params)
    {
        //追加表单字段
        if( in_array($params['name'],['user_create','user_edit']) ){
            $params['items'] = array_merge($params['items'], [
                [
                    'type'        => 'text',
                    'name'        => 'user_token',
                    'id'          => 'user_token',
                    'title'       => lang('user_token'),
                    'placeholder' => lang('user_token_placeholder'),
                    'tips'        => '',
                    'value'       => $params['data']['user_token'],
                    'readonly'    => false,
                    'disabled'    => false,
                    'required'    => false,
                    'class'       => 'row form-group',
                    'class_tips'  => '',
                    'class_left'  => 'col-12',
                    'class_right' => 'col-12',
                ],
                [
                    'type'        => 'text',
                    'name'        => 'user_nice_name',
                    'id'          => 'user_nice_name',
                    'title'       => lang('user_nice_name'),
                    'placeholder' => lang('user_nice_name_placeholder'),
                    'tips'        => '',
                    'value'       => $params['data']['user_nice_name'],
                    'readonly'    => false,
                    'disabled'    => false,
                    'required'    => false,
                    'class'       => 'row form-group',
                    'class_tips'  => '',
                    'class_left'  =>'col-12',
                    'class_right' =>'col-12',
                ],
                [
                    'type'        => 'number',
                    'name'        => 'user_score',
                    'id'          => 'user_score',
                    'title'       => lang('user_score'),
                    'placeholder' => lang('user_score_placeholder'),
                    'tips'        => '',
                    'value'       => $params['data']['user_score'],
                    'readonly'    => false,
                    'disabled'    => false,
                    'required'    => false,
                    'class'       => 'row form-group',
                    'class_tips'  => '',
                    'class_left'  =>'col-12',
                    'class_right' =>'col-12',
                ],
                [
                    'type'        => 'number',
                    'name'        => 'user_pid',
                    'id'          => 'user_pid',
                    'title'       => lang('user_pid'),
                    'placeholder' => lang('user_pid_placeholder'),
                    'tips'        => '',
                    'value'       => $params['data']['user_pid'],
                    'readonly'    => false,
                    'disabled'    => false,
                    'required'    => false,
                    'class'       => 'row form-group',
                    'class_tips'  => '',
                    'class_left'  =>'col-12',
                    'class_right' =>'col-12',
                ],
            ]);
        }
    }
    
    // 表格数据
    public function tableBuild(&$params)
    {
        if($params['data-unique-id'] == 'user_id'){
            $params['columns'] = DcArrayPush($params['columns'], [
                [
                    'data-field'  => 'user_views',
                    'data-title'  => lang('user_views'),
                    'data-align'  => 'center',
                    'data-halign' => 'center',
                ],
                [
                    'data-field'  => 'user_score',
                    'data-title'  => lang('user_score'),
                    'data-align'  => 'center',
                    'data-halign' => 'center',
                ],
                [
                    'data-field'  => 'user_pid',
                    'data-title'  => lang('user_pid'),
                    'data-align'  => 'center',
                    'data-halign' => 'center',
                ],
            ], 7);
        }
    }
    
    // 用户注册前
    public function userRegisterBefore(&$post){
        $post['user_pid']          = userPidGet();
        $post['user_score']        = intval(config('user.register_score'));
        return $post;
    }
    
    // 用户注册后
    public function userRegisterAfter(&$user){
        
    }
    
    // 用户登录前
    public function userLoginBefore(&$post){
    }
    
    // 用户登录后
    public function userLoginAfter(&$data){
        
    }
}