<?php
namespace app\user\controller;

use app\common\controller\Front;

class Index extends Front
{
    
    public function _initialize()
    {
		parent::_initialize();
    }
    
    public function index()
    {
        return $this->fetch();
    }
    
    public function slug()
    {
        dump('slug');
    }
    
    public function id()
    {
        dump('id');
    }
    
	public function register()
    {
        if( $this->site['user']['user_id'] ){
            $this->redirect(DcUrl('user/center/index','',''), 302);
        }
        if( $this->request->isPost() ){
            //验证码
            $this->validateCaptcha(input('post.user_captcha'));
            //验证规则
            config('common.validate_name', config('user.register_validate_name') );
            config('common.validate_scene', config('user.register_validate_scene') );
            config('common.where_slug_unique', config('user.register_where_slug') );
            //调用注册接口
            $user = \daicuo\User::register(input('post.'));
            //返回结果
            if($user['user_id']){
                //自动登录
                \daicuo\User::set_auth_cookie($user['user_id']);
                //是否授权回跳
                $this->callBack($user, input('post.callback/u'), input('post.state/s'));
                //直接返回
                $this->success(lang('success'), 'user/center/index');
            }else{
                $this->success(DcError(\daicuo\User::getError()));
            }
        }
        userPidSet();//设置上级用户ID
		return $this->fetch();
	}
    
    public function login()
    {
        if( $this->site['user']['user_id'] ){
            $this->redirect(DcUrl('user/center/index','',''), 302);
        }
        if( $this->request->isPost() ){
            //验证码
            $this->validateCaptcha(input('post.user_captcha'));
            //验证用户名密码
            $post = [];
            $post['user_name']   = input('post.user_name/s');
            $post['user_pass']   = input('post.user_pass/s');
            $post['user_expire'] = input('post.user_expire/d',0);
            if( $result = \daicuo\User::login($post) ){
                //当前登录用户信息
                $user = \daicuo\User::get_current_user();
                //是否授权回跳
                $this->callBack($user, input('post.callback/u'), input('post.state/s'));
                //直接返回
                $this->success(lang('success'), 'user/center/index');
            }else{
                $this->error( DcError(\daicuo\User::getError()) );
            }
        }
        return $this->fetch();
    }
    
    public function logout()
    {
        \daicuo\User::logout();
        
        $this->success(lang('success'), 'user/index/login');
    }
    
    /**
     * 验证码验证
     * @param string $captcha 用户输入的验证码
     * @return array 用户信息
     */
    private function validateCaptcha($captcha='')
    {
        if( DcBool(config('common.site_captcha')) ){
            if(captcha_check($captcha) == false){
                $this->error( DcError(lang('user_captcha_error')) );
            }
        }
    }
    
    /**
     * 授权回跳、不需要跳转时返回用户信息
     * @param array $user 当前用户信息
     * @param string $bakUrl 回跳网关
     * @param string $state 自定义参数
     * @return array 当前登录的用户信息
     */
    private function callBack($user, $bakUrl='', $state='')
    {
        $redirect = model('user/Common','Loglic')->callBack(['user_token'=>$user['user_token'],'user_expire'=>$user['user_expire']], $bakUrl, $state);
        if( $redirect ){
            $this->redirect($redirect, 302);
        }
    }
}