<?php
namespace app\user\controller;

use app\common\controller\Api;

class Token extends Api
{
    // 初始化
    public function _initialize()
    {
        $this->auth['none_login'] = ['user/token/index','user/token/login'];
        
		parent::_initialize();
    }
    
    // 通过code换取Token?code=xxx
    public function index()
    {
        $code = str_replace(['%20',' '], '+', input('get.code/s',''));
        
        $code = DcDesDecode($code, config('user.callback_secret'));
        
        if(!$code){
            $this->error( lang('token_secret_error') );
        }
        
        //拆分CODE
        list($token, $expire, $time) = explode(',', $code);
        
        //临时CODE超时
        if( time()-$time > 7200){
            $this->error( lang('token_code_overtime') );
        }
        
        //返回token
        $this->success( lang('success'), ['user_token'=>$token, 'user_expire'=>$expire] );
    }
    
    /**
     * 登录获取Token(支持授权回调：api/tokin/login/?callbak=xxxx&state=1)
     * @return array
     */
    public function login()
    {
        //验证码
        if( DcBool(config('common.site_captcha')) ){
            if(captcha_check(input('request.user_captcha')) == false){
                $this->error( DcError(lang('user_captcha_error')) );
            }
        }
        //验证用户名密码
        $data = \daicuo\User::token_login(input('request.user_name/s'), input('request.user_pass/s'));
        if( $data ){
            //是否回跳
            $callbak = model('user/Common','Loglic')->callBack($data, input('post.callback/u',''), input('post.state/s'));
            if( $callbak ){
                $this->redirect($callbak, 302);
            }
            $this->success( lang('success'), $data );
        }else{
            $this->error( DcError(\daicuo\User::getError()) );
        }
	}
}